/*
 *	fram.c
 *
 *	Intellivision/EMU
 *
 *	* Mon May 23 00:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

#if 1

/****************************************************************************
 *	
 ****************************************************************************/

/* %r10 cp1610_read(%r12); */
asm("
	.code
	.align	1
	.global	cp1610_read
cp1610_read:
	xand	%r9, %r12, 0xf000	; %r9 = aaaa0000 00000000
	xsrl	%r9, 10			; %r9 = 00000000 00aaaa00
	ext	cp1610_read_TBL@ah
	ext	cp1610_read_TBL@al
	ld.w	%r9, [%r9]
	jp	%r9
	;-------------------------------;
cp1610_read_0:
	xcmp	%r12, 0x0040		; $0000-$003F: STIC (16bit)
	xjrlt	cp1610_read_stic
	xcmp	%r12, 0x0100		; $0040-$00FF: (blank)
	xjrlt	cp1610_read_X
	xcmp	%r12, 0x01f0		; $0100-$01EF: Scratchpad RAM (8bit)
	xjrlt	cp1610_read_ram1
	xcmp	%r12, 0x0200		; $01F0-$01FF: AY-3-8914 (8bit)
	xjrlt	cp1610_read_ay38914
	xcmp	%r12, 0x0360		; $0200-$035F: System RAM (16bit)
	xjrlt	cp1610_read_ram2
	xjp	cp1610_read_X		; $0360-$0FFF: (blank)
cp1610_read_stic:
	xcall	cp1610_leave
	xcall	stic_read
	xjp	cp1610_enter
cp1610_read_ram1:
	ext	ram1-0x0100@ah
	ext	ram1-0x0100@al
	ld.ub	%r10, [%r12]
	ret
cp1610_read_ay38914:
	xcall	cp1610_leave
	xsub	%r12, %r12, 0x01f0
	xcall	ay38914_read
	xjp	cp1610_enter
cp1610_read_ram2:
	xsll	%r12, 1			; %r12 =   0x0200*2..
	ext	ram2-0x0400@ah		; ext ram2-0x0200*2@ah
	ext	ram2-0x0400@al		; ext ram2-0x0200*2@al
	ld.uh	%r10, [%r12]
	ret
	;-------------------------------;
cp1610_read_1:
	xsll	%r12, 1			; %r12 =   0x1000*2..
	ext	exec-0x2000@ah		; ext exec-0x1000*2@ah
	ext	exec-0x2000@al		; ext exec-0x1000*2@al
	ld.uh	%r10, [%r12]
	ret
	;-------------------------------;
cp1610_read_3:
	xcmp	%r12, 0x3a00		; $3000-$39FF: GROM / GRAM (8bit)
	xjrlt	cp1610_read_gmem
	xjp	cp1610_read_X		; $3A00-$3FFF: (blank)
cp1610_read_gmem:
	ext	gmem-0x3000@ah
	ext	gmem-0x3000@al
	ld.ub	%r10, [%r12]
	ret
	;-------------------------------;
cp1610_read_5:
	xsll	%r12, 1			; %r12 =   0x5000*2..
	ext	cart-0xa000@ah		; ext cart-0x5000*2@ah
	ext	cart-0xa000@al		; ext cart-0x5000*2@al
	ld.uh	%r10, [%r12]
	ret
	;-------------------------------;
cp1610_read_X:
	xld.w	%r10, 0xffff
	ret
	;-------------------------------;
	.align	2
cp1610_read_TBL:
	.word	cp1610_read_0		; $0000-$0000
	.word	cp1610_read_1		; $1000-$1000
	.word	cp1610_read_X		; $2000-$2000
	.word	cp1610_read_3		; $3000-$3000
	.word	cp1610_read_X		; $4000-$4000
	.word	cp1610_read_5		; $5000-$5000
	.word	cp1610_read_X		; $6000-$6000
	.word	cp1610_read_X		; $7000-$7000
	.word	cp1610_read_X		; $8000-$8000
	.word	cp1610_read_X		; $9000-$9000
	.word	cp1610_read_X		; $A000-$A000
	.word	cp1610_read_X		; $B000-$B000
	.word	cp1610_read_X		; $C000-$C000
	.word	cp1610_read_X		; $D000-$D000
	.word	cp1610_read_X		; $E000-$E000
	.word	cp1610_read_X		; $F000-$F000
");

/* void cp1610_write(%r12, %r13); */
asm("
	.code
	.align	1
	.global	cp1610_write
cp1610_write:
	xand	%r9, %r12, 0xf000	; %r9 = aaaa0000 00000000
	xsrl	%r9, 10			; %r9 = 00000000 00aaaa00
	ext	cp1610_write_TBL@ah
	ext	cp1610_write_TBL@al
	ld.w	%r9, [%r9]
	jp	%r9
	;-------------------------------;
cp1610_write_0:
	xcmp	%r12, 0x0040		; $0000-$003F: STIC (16bit)
	xjrlt	cp1610_write_stic
	xcmp	%r12, 0x0100		; $0040-$00FF: (blank)
	xjrlt	cp1610_write_X
	xcmp	%r12, 0x01f0		; $0100-$01EF: Scratchpad RAM (8bit)
	xjrlt	cp1610_write_ram1
	xcmp	%r12, 0x0200		; $01F0-$01FF: AY-3-8914 (8bit)
	xjrlt	cp1610_write_ay38914
	xcmp	%r12, 0x0360		; $0200-$035F: System RAM (16bit)
	xjrlt	cp1610_write_ram2
	xjp	cp1610_write_X		; $0360-$0FFF: (blank)
cp1610_write_stic:
	xcall	cp1610_leave
	xcall	stic_write
	xjp	cp1610_enter
cp1610_write_ram1:
	ext	ram1-0x0100@ah
	ext	ram1-0x0100@al
	ld.b	[%r12], %r13
	ret
cp1610_write_ay38914:
	xcall	cp1610_leave
	xsub	%r12, %r12, 0x01f0
	xcall.d	ay38914_write
	ld.ub	%r13, %r13		; *delay*
	xjp	cp1610_enter
cp1610_write_ram2:
	xsll	%r12, 1			; %r12 =   0x0200*2..
	ext	ram2-0x0400@ah		; ext ram2-0x0200*2@ah
	ext	ram2-0x0400@al		; ext ram2-0x0200*2@al
	ld.h	[%r12], %r13
	ret
	;-------------------------------;
cp1610_write_3:
	xcmp	%r12, 0x3800		; $3000-$37FF: (blank)
	xjrlt	cp1610_write_X
	xcmp	%r12, 0x3a00		; $3800-$39FF: GRAM (8bit)
	xjrlt	cp1610_write_gmem
	xjp	cp1610_write_X		; $3A00-$3FFF: (blank)
cp1610_write_gmem:
	ext	gmem-0x3000@ah
	ext	gmem-0x3000@al
	ld.b	[%r12], %r13
	ret
	;-------------------------------;
cp1610_write_X:
	ret
	;-------------------------------;
	.align	2
cp1610_write_TBL:
	.word	cp1610_write_0		; $0000-$0FFF
	.word	cp1610_write_X		; $1000-$1FFF
	.word	cp1610_write_X		; $2000-$2FFF
	.word	cp1610_write_3		; $3000-$3FFF
	.word	cp1610_write_X		; $4000-$4FFF
	.word	cp1610_write_X		; $5000-$5FFF
	.word	cp1610_write_X		; $6000-$6FFF
	.word	cp1610_write_X		; $7000-$7FFF
	.word	cp1610_write_X		; $8000-$8FFF
	.word	cp1610_write_X		; $9000-$9FFF
	.word	cp1610_write_X		; $A000-$AFFF
	.word	cp1610_write_X		; $B000-$BFFF
	.word	cp1610_write_X		; $C000-$CFFF
	.word	cp1610_write_X		; $D000-$DFFF
	.word	cp1610_write_X		; $E000-$EFFF
	.word	cp1610_write_X		; $F000-$FFFF
");

/****************************************************************************
 *	
 ****************************************************************************/

#else

asm("
	.code
	.align	1
	.global	cp1610_read
cp1610_read:
	xcall	cp1610_leave
	xcall	cp1610_read_C
	xjp	cp1610_enter
");

asm("
	.code
	.align	1
	.global	cp1610_write
cp1610_write:
	xcall	cp1610_leave
	xcall	cp1610_write_C
	xjp	cp1610_enter
");

int
cp1610_read_C(int addr)
{
	ASSERT((addr >= 0) && (addr <= 0xffff));
	switch(addr & 0xf000) {
	case 0x0000:
		       if(addr < 0x0040) {
			return stic_read(addr - 0x0000);
		} else if(addr < 0x0100) {
			break;
		} else if(addr < 0x01f0) {
			return ram1[addr - 0x0100];
		} else if(addr < 0x0200) {
			//return ay38914_read(addr - 0x01f0);
			return ram1[addr - 0x0100];
		} else if(addr < 0x0360) {
			return ram2[addr - 0x0200];
		} else {
			break;
		}
	case 0x1000:
		return exec[addr - 0x1000];
	case 0x3000:
		if(addr < 0x3a00) {
			return gmem[addr - 0x3000];
		} else {
			break;
		}
	case 0x5000:
		return cart[addr - 0x5000];
	}
	return 0xffff;
}

void
cp1610_write_C(int addr, int data)
{
	ASSERT((addr >= 0) && (addr <= 0xffff));
	ASSERT((data >= 0) && (data <= 0xffff));
	switch(addr & 0xf000) {
	case 0x0000:
		       if(addr < 0x0040) {
			stic_write(addr - 0x0000, data);
			return;
		} else if(addr < 0x0100) {
			return;
		} else if(addr < 0x01f0) {
			ram1[addr - 0x0100] = data;
			return;
		} else if(addr < 0x0200) {
			//ay38914_write(addr - 0x01f0, (unsigned char)data);
			ram1[addr - 0x0100] = data;
			return;
		} else if(addr < 0x0360) {
			ram2[addr - 0x0200] = data;
			return;
		} else {
			return;
		}
	case 0x3000:
		if(addr < 0x3800) {
			return;
		} else if(addr < 0x3a00) {
			gmem[addr - 0x3000] = data;
			return;
		} else {
			return;
		}
	}
}

#endif

